Index: help.h
===================================================================
--- help.h	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ help.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,3 +1,3 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -27,13 +27,15 @@
 #define _HELP_H
 
-typedef union {
+typedef union
+{
 	off_t file_offset;
 	char *mem_offset;
 } help_off_t;
 
-typedef struct help {
+typedef struct help
+{
 	int fd;
 	time_t mtime;
-	char *title;
+	char *string;
 	help_off_t offset;
 	int length;
@@ -41,9 +43,6 @@
 } help_t;
 
-G_GNUC_MALLOC help_t *help_init(help_t **help, const char *helpfile);
-void help_free(help_t **help);
-char *help_get(help_t **help, char *title);
-int help_add_mem(help_t **help, const char *title, const char *content_);
-char *help_get_whatsnew(help_t **help, int old);
+help_t *help_init( help_t **help );
+char *help_get( help_t **help, char *string );
 
 #endif
Index: ini.c
===================================================================
--- ini.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ ini.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,90 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* INI file reading code						*/
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+#define BITLBEE_CORE
+#include "bitlbee.h"
+
+ini_t *ini_open( char *file )
+{
+	ini_t *ini = g_new0( ini_t, 1 );
+	
+	if( ( ini->fp = fopen( file, "r" ) ) == NULL )
+	{
+		g_free( ini );
+		return( NULL );
+	}
+	
+	return( ini );
+}
+
+int ini_read( ini_t *file )
+{
+	char key[MAX_STRING], s[MAX_STRING], *t;
+	int i;
+	
+	while( !feof( file->fp ) )
+	{
+		*s = 0;
+		fscanf( file->fp, "%127[^\n#]s", s );
+		fscanf( file->fp, "%*[^\n]s" );
+		fgetc( file->fp );		/* Skip newline		*/
+		file->line ++;
+		if( strchr( s, '=' ) )
+		{
+			sscanf( s, "%[^ =]s", key );
+			if( ( t = strchr( key, '.' ) ) )
+			{
+				*t = 0;
+				strcpy( file->section, key );
+				t ++;
+			}
+			else
+			{
+				strcpy( file->section, file->c_section );
+				t = key;
+			}
+			sscanf( t, "%s", file->key );
+			t = strchr( s, '=' ) + 1;
+			for( i = 0; t[i] == ' '; i ++ );
+			strcpy( file->value, &t[i] );
+			for( i = strlen( file->value ) - 1; file->value[i] == 32; i -- )
+				file->value[i] = 0;
+			
+			return( 1 );
+		}
+		else if( ( t = strchr( s, '[' ) ) )
+		{
+			strcpy( file->c_section, t + 1 );
+			t = strchr( file->c_section, ']' );
+			*t = 0;
+		}
+	}
+	return( 0 );
+}
+
+void ini_close( ini_t *file )
+{
+	fclose( file->fp );
+	g_free( file );
+}
Index: ini.h
===================================================================
--- ini.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ ini.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,43 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* INI file reading code						*/
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#ifndef _INI_H
+#define _INI_H
+
+typedef struct
+{
+	FILE *fp;
+	int line;
+	char c_section[MAX_STRING];
+	char section[MAX_STRING];
+	char key[MAX_STRING];
+	char value[MAX_STRING];
+} ini_t;
+
+ini_t *ini_open( char *file );
+int ini_read( ini_t *file );
+void ini_close( ini_t *file );
+
+#endif
Index: irc.c
===================================================================
--- irc.c	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ irc.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,9 +1,9 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2012 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
-/* The IRC-based UI (for now the only one)                              */
+/* The big hairy IRCd part of the project                               */
 
 /*
@@ -20,505 +20,349 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
+#define BITLBEE_CORE
 #include "bitlbee.h"
-#include "canohost.h"
-#include "ipc.h"
-#include "dcc.h"
-#include "lib/ssl_client.h"
-
-GSList *irc_connection_list;
-GSList *irc_plugins;
-
-static gboolean irc_userping(gpointer _irc, gint fd, b_input_condition cond);
-static char *set_eval_charset(set_t *set, char *value);
-static char *set_eval_password(set_t *set, char *value);
-static char *set_eval_bw_compat(set_t *set, char *value);
-static char *set_eval_utf8_nicks(set_t *set, char *value);
-
-irc_t *irc_new(int fd)
-{
-	irc_t *irc;
-	irc_user_t *iu;
-	GSList *l;
-	set_t *s;
-	bee_t *b;
-
-	irc = g_new0(irc_t, 1);
-
+#include "crypting.h"
+
+static gboolean irc_userping( gpointer _irc );
+
+GSList *irc_connection_list = NULL;
+
+irc_t *irc_new( int fd )
+{
+	irc_t *irc = g_new0( irc_t, 1 );
+	
+	struct sockaddr_in sock[1];
+#ifdef IPV6
+	struct sockaddr_in6 sock6[1];
+#endif
+	struct hostent *peer;
+	unsigned int i, j;
+	
 	irc->fd = fd;
-	sock_make_nonblocking(irc->fd);
-
-	irc->r_watch_source_id = b_input_add(irc->fd, B_EV_IO_READ, bitlbee_io_current_client_read, irc);
-
+	irc->io_channel = g_io_channel_unix_new( fd );
+#ifdef GLIB2
+	g_io_channel_set_encoding (irc->io_channel, NULL, NULL);
+	g_io_channel_set_buffered (irc->io_channel, FALSE);
+	g_io_channel_set_flags( irc->io_channel, G_IO_FLAG_NONBLOCK, NULL );
+#else
+	fcntl( irc->fd, F_SETFL, O_NONBLOCK);
+#endif
+	irc->r_watch_source_id = g_io_add_watch( irc->io_channel, G_IO_IN | G_IO_ERR | G_IO_HUP, bitlbee_io_current_client_read, irc );
+	
 	irc->status = USTATUS_OFFLINE;
 	irc->last_pong = gettime();
-
-	irc->nick_user_hash = g_hash_table_new(g_str_hash, g_str_equal);
-	irc->watches = g_hash_table_new(g_str_hash, g_str_equal);
-
-	irc->iconv = (GIConv) - 1;
-	irc->oconv = (GIConv) - 1;
-
-	irc->sendbuffer = g_string_sized_new(IRC_MAX_LINE * 2);
-
-	if (global.conf->ping_interval > 0 && global.conf->ping_timeout > 0) {
-		irc->ping_source_id = b_timeout_add(global.conf->ping_interval * 1000, irc_userping, irc);
-	}
-
-	irc_connection_list = g_slist_append(irc_connection_list, irc);
-
-	b = irc->b = bee_new();
-	b->ui_data = irc;
-	b->ui = &irc_ui_funcs;
-
-	s = set_add(&b->set, "allow_takeover", "true", set_eval_bool, irc);
-	s = set_add(&b->set, "away_devoice", "true", set_eval_bw_compat, irc);
-	s->flags |= SET_HIDDEN;
-	s = set_add(&b->set, "away_reply_timeout", "3600", set_eval_int, irc);
-	s = set_add(&b->set, "charset", "utf-8", set_eval_charset, irc);
-	s = set_add(&b->set, "default_target", "root", NULL, irc);
-	s = set_add(&b->set, "display_namechanges", "false", set_eval_bool, irc);
-	s = set_add(&b->set, "display_timestamps", "true", set_eval_bool, irc);
-	s = set_add(&b->set, "handle_unknown", "add_channel", NULL, irc);
-	s = set_add(&b->set, "last_version", "0", NULL, irc);
-	s->flags |= SET_HIDDEN;
-	s = set_add(&b->set, "nick_format", "%-@nick", NULL, irc);
-	s = set_add(&b->set, "nick_lowercase", "false", set_eval_bool, irc);
-	s = set_add(&b->set, "nick_underscores", "false", set_eval_bool, irc);
-	s = set_add(&b->set, "offline_user_quits", "true", set_eval_bool, irc);
-	s = set_add(&b->set, "ops", "both", set_eval_irc_channel_ops, irc);
-	s = set_add(&b->set, "paste_buffer", "false", set_eval_bool, irc);
-	s->old_key = g_strdup("buddy_sendbuffer");
-	s = set_add(&b->set, "paste_buffer_delay", "200", set_eval_int, irc);
-	s->old_key = g_strdup("buddy_sendbuffer_delay");
-	s = set_add(&b->set, "password", NULL, set_eval_password, irc);
-	s->flags |= SET_NULL_OK | SET_PASSWORD;
-	s = set_add(&b->set, "private", "true", set_eval_bool, irc);
-	s = set_add(&b->set, "query_order", "lifo", NULL, irc);
-	s = set_add(&b->set, "root_nick", ROOT_NICK, set_eval_root_nick, irc);
-	s->flags |= SET_HIDDEN;
-	s = set_add(&b->set, "show_offline", "false", set_eval_bw_compat, irc);
-	s->flags |= SET_HIDDEN;
-	s = set_add(&b->set, "self_messages", "true", set_eval_self_messages, irc);
-	s = set_add(&b->set, "simulate_netsplit", "true", set_eval_bool, irc);
-	s = set_add(&b->set, "timezone", "local", set_eval_timezone, irc);
-	s = set_add(&b->set, "to_char", ": ", set_eval_to_char, irc);
-	s = set_add(&b->set, "typing_notice", "false", set_eval_bool, irc);
-	s = set_add(&b->set, "utf8_nicks", "false", set_eval_utf8_nicks, irc);
-
-	irc->root = iu = irc_user_new(irc, ROOT_NICK);
-	iu->fullname = g_strdup(ROOT_FN);
-	iu->f = &irc_user_root_funcs;
-
-	iu = irc_user_new(irc, NS_NICK);
-	iu->fullname = g_strdup(ROOT_FN);
-	iu->f = &irc_user_root_funcs;
-
-	irc->user = g_new0(irc_user_t, 1);
-	
-	irc_set_hosts(irc, NULL, 0);
-
-	conf_loaddefaults(irc);
-
-	/* Evaluator sets the iconv/oconv structures. */
-	set_eval_charset(set_find(&b->set, "charset"), set_getstr(&b->set, "charset"));
-
-	irc_write(irc, ":%s NOTICE * :%s", irc->root->host, "BitlBee-IRCd initialized, please go on");
-	if (isatty(irc->fd)) {
-		irc_write(irc, ":%s NOTICE * :%s", irc->root->host,
-		          "If you read this, you most likely accidentally "
-		          "started BitlBee in inetd mode on the command line.");
-		irc_write(irc, ":%s NOTICE * :%s", irc->root->host,
-		          "You probably want to run it as a system service, "
-		          "or use (Fork)Daemon mode with the -F or -D switches. "
-		          "See doc/README or 'man bitlbee' for more information.");
-	}
-
-	/* libpurple doesn't like fork()s after initializing itself, so this
-	   is the right moment to initialize it. */
-#ifdef WITH_PURPLE
-	nogaim_init();
+	
+	irc->userhash = g_hash_table_new( g_str_hash, g_str_equal );
+	irc->watches = g_hash_table_new( g_str_hash, g_str_equal );
+	
+	strcpy( irc->umode, UMODE );
+	irc->mynick = g_strdup( ROOT_NICK );
+	irc->channel = g_strdup( ROOT_CHAN );
+	
+	i = sizeof( *sock );
+#ifdef IPV6
+	j = sizeof( *sock6 );
 #endif
-
-	/* SSL library initialization also should be done after the fork, to
-	   avoid shared CSPRNG state. This is required by NSS, which refuses to
-	   work if a fork is detected */
-	ssl_init();
-
-	for (l = irc_plugins; l; l = l->next) {
-		irc_plugin_t *p = l->data;
-		if (p->irc_new) {
-			p->irc_new(irc);
-		}
-	}
-
-	return irc;
-}
-
-void irc_set_hosts(irc_t *irc, const struct sockaddr *remote_addr, const socklen_t remote_addrlen)
-{
-	struct sockaddr_storage sock;
-	socklen_t socklen = sizeof(sock);
-	char *host = NULL, *myhost = NULL;
-	struct irc_user *iu;
-
-	if (global.conf->hostname) {
-		myhost = g_strdup(global.conf->hostname);
-	} else if (getsockname(irc->fd, (struct sockaddr*) &sock, &socklen) == 0) {
-		myhost = reverse_lookup((struct sockaddr*) &sock, socklen);
-	}
-
-	if (remote_addrlen > 0) {
-		host = reverse_lookup(remote_addr, remote_addrlen);
-	} else if (getpeername(irc->fd, (struct sockaddr*) &sock, &socklen) == 0) {
-		host = reverse_lookup((struct sockaddr*) &sock, socklen);
-	}
-
-	if (myhost == NULL) {
-		myhost = g_strdup("localhost.localdomain");
-	}
-	if (host == NULL) {
-		host = g_strdup("localhost.localdomain");
-	}
-	
-	if (irc->root->host != irc->root->nick) {
-		g_free(irc->root->host);
-	}
-	irc->root->host = g_strdup(myhost);
-	if ((iu = irc_user_by_name(irc, NS_NICK))) {
-		if (iu->host != iu->nick) {
-			g_free(iu->host);
-		}
-		iu->host = g_strdup(myhost);
-	}
-	
-	if (irc->user->host != irc->user->nick) {
-		g_free(irc->user->host);
-	}
-	irc->user->host = g_strdup(host);
-
-	g_free(myhost);
-	g_free(host);
-}
-
-/* immed=1 makes this function pretty much equal to irc_free(), except that
-   this one will "log". In case the connection is already broken and we
-   shouldn't try to write to it. */
-void irc_abort(irc_t *irc, int immed, char *format, ...)
-{
-	char *reason = NULL;
-
-	if (format != NULL) {
-		va_list params;
-
-		va_start(params, format);
-		reason = g_strdup_vprintf(format, params);
-		va_end(params);
-	}
-
-	if (reason) {
-		irc_write(irc, "ERROR :Closing link: %s", reason);
-	}
-
-	ipc_to_master_str("OPERMSG :Client exiting: %s@%s [%s]\r\n",
-	                  irc->user->nick ? irc->user->nick : "(NONE)",
-	                  irc->user->host, reason ? : "");
-
-	g_free(reason);
-
-	irc_flush(irc);
-	if (immed) {
-		irc_free(irc);
-	} else {
-		b_event_remove(irc->ping_source_id);
-		irc->ping_source_id = b_timeout_add(1, (b_event_handler) irc_free, irc);
-	}
-}
-
-static gboolean irc_free_hashkey(gpointer key, gpointer value, gpointer data);
-
+	if( global.conf->hostname )
+		irc->myhost = g_strdup( global.conf->hostname );
+	else if( getsockname( irc->fd, (struct sockaddr*) sock, &i ) == 0 && sock->sin_family == AF_INET )
+	{
+		if( ( peer = gethostbyaddr( (char*) &sock->sin_addr, sizeof( sock->sin_addr ), AF_INET ) ) )
+			irc->myhost = g_strdup( peer->h_name );
+	}
+#ifdef IPV6
+	else if( getsockname( irc->fd, (struct sockaddr*) sock6, &j ) == 0 && sock6->sin6_family == AF_INET6 )
+	{
+		if( ( peer = gethostbyaddr( (char*) &sock6->sin6_addr, sizeof( sock6->sin6_addr ), AF_INET6 ) ) )
+			irc->myhost = g_strdup( peer->h_name );
+	}
+#endif
+	
+	i = sizeof( *sock );
+#ifdef IPV6
+	j = sizeof( *sock6 );
+#endif
+	if( getpeername( irc->fd, (struct sockaddr*) sock, &i ) == 0 && sock->sin_family == AF_INET )
+	{
+		if( ( peer = gethostbyaddr( (char*) &sock->sin_addr, sizeof( sock->sin_addr ), AF_INET ) ) )
+			irc->host = g_strdup( peer->h_name );
+	}
+#ifdef IPV6
+	else if( getpeername( irc->fd, (struct sockaddr*) sock6, &j ) == 0 && sock6->sin6_family == AF_INET6 )
+	{
+		if( ( peer = gethostbyaddr( (char*) &sock6->sin6_addr, sizeof( sock6->sin6_addr ), AF_INET6 ) ) )
+			irc->host = g_strdup( peer->h_name );
+	}
+#endif
+	
+	if( !irc->host ) irc->host = g_strdup( "localhost." );
+	if( !irc->myhost ) irc->myhost = g_strdup( "localhost." );
+
+	if( global.conf->ping_interval > 0 && global.conf->ping_timeout > 0 )
+		irc->ping_source_id = g_timeout_add( global.conf->ping_interval * 1000, irc_userping, irc );
+	
+	irc_write( irc, ":%s NOTICE AUTH :%s", irc->myhost, "BitlBee-IRCd initialized, please go on" );
+
+	irc_connection_list = g_slist_append( irc_connection_list, irc );
+	
+	set_add( irc, "away_devoice", "true",  set_eval_away_devoice );
+	set_add( irc, "auto_connect", "true", set_eval_bool );
+	set_add( irc, "auto_reconnect", "false", set_eval_bool );
+	set_add( irc, "auto_reconnect_delay", "300", set_eval_int );
+	set_add( irc, "buddy_sendbuffer", "false", set_eval_bool );
+	set_add( irc, "buddy_sendbuffer_delay", "1", set_eval_int );
+	set_add( irc, "charset", "iso8859-1", set_eval_charset );
+	set_add( irc, "debug", "false", set_eval_bool );
+	set_add( irc, "default_target", "root", NULL );
+	set_add( irc, "display_namechanges", "false", set_eval_bool );
+	set_add( irc, "handle_unknown", "root", NULL );
+	/* set_add( irc, "html", "nostrip", NULL ); */
+	set_add( irc, "lcnicks", "true", set_eval_bool );
+	set_add( irc, "ops", "both", set_eval_ops );
+	set_add( irc, "private", "true", set_eval_bool );
+	set_add( irc, "query_order", "lifo", NULL );
+	set_add( irc, "save_on_quit", "true", set_eval_bool );
+	set_add( irc, "to_char", ": ", set_eval_to_char );
+	set_add( irc, "typing_notice", "false", set_eval_bool );
+	
+	conf_loaddefaults( irc );
+	
+	return( irc );
+}
+
+static gboolean irc_free_userhash( gpointer key, gpointer value, gpointer data )
+{
+	g_free( key );
+	
+	return( TRUE );
+}
+
+/* Because we have no garbage collection, this is quite annoying */
 void irc_free(irc_t * irc)
 {
-	GSList *l;
-	GHashTableIter iter;
-	gpointer itervalue;
-
-	irc->status |= USTATUS_SHUTDOWN;
-
-	log_message(LOGLVL_INFO, "Destroying connection with fd %d", irc->fd);
-
-	if (irc->status & USTATUS_IDENTIFIED && set_getbool(&irc->b->set, "save_on_quit")) {
-		if (storage_save(irc, NULL, TRUE) != STORAGE_OK) {
-			log_message(LOGLVL_WARNING, "Error while saving settings for user %s", irc->user->nick);
-		}
-	}
-
-	for (l = irc_plugins; l; l = l->next) {
-		irc_plugin_t *p = l->data;
-		if (p->irc_free) {
-			p->irc_free(irc);
-		}
-	}
-
-	irc_connection_list = g_slist_remove(irc_connection_list, irc);
-
-	while (irc->queries != NULL) {
+	account_t *account, *accounttmp;
+	user_t *user, *usertmp;
+	nick_t *nick, *nicktmp;
+	help_t *helpnode, *helpnodetmp;
+	set_t *setnode, *setnodetmp;
+	
+	log_message( LOGLVL_INFO, "Destroying connection with fd %d", irc->fd );
+	
+	if( irc->status >= USTATUS_IDENTIFIED && set_getint( irc, "save_on_quit" ) ) 
+		if( !bitlbee_save( irc ) )
+			irc_usermsg( irc, "Error while saving settings!" );
+	
+	if( irc->ping_source_id > 0 )
+		g_source_remove( irc->ping_source_id );
+	g_source_remove( irc->r_watch_source_id );
+	if( irc->w_watch_source_id > 0 )
+		g_source_remove( irc->w_watch_source_id );
+	g_io_channel_close( irc->io_channel );
+	g_io_channel_unref( irc->io_channel );
+	irc_connection_list = g_slist_remove( irc_connection_list, irc );
+	
+	for (account = irc->accounts; account; account = account->next)
+		if (account->gc)
+			signoff(account->gc);
+	
+	g_free(irc->sendbuffer);
+	g_free(irc->readbuffer);
+	
+	g_free(irc->nick);
+	g_free(irc->user);
+	g_free(irc->host);
+	g_free(irc->realname);
+	g_free(irc->password);
+	
+	g_free(irc->myhost);
+	g_free(irc->mynick);
+	
+	g_free(irc->channel);
+	
+	while (irc->queries != NULL)
 		query_del(irc, irc->queries);
-	}
-
-	/* This is a little bit messy: bee_free() frees all b->users which
-	   calls us back to free the corresponding irc->users. So do this
-	   before we clear the remaining ones ourselves. */
-	bee_free(irc->b);
-
-	g_hash_table_iter_init(&iter, irc->nick_user_hash);
-
-	while (g_hash_table_iter_next(&iter, NULL, &itervalue)) {
-		g_hash_table_iter_remove(&iter);
-		irc_user_free(irc, (irc_user_t *) itervalue);
-	}
-
-	while (irc->channels) {
-		irc_channel_free(irc->channels->data);
-	}
-
-	if (irc->ping_source_id > 0) {
-		b_event_remove(irc->ping_source_id);
-	}
-	if (irc->r_watch_source_id > 0) {
-		b_event_remove(irc->r_watch_source_id);
-	}
-	if (irc->w_watch_source_id > 0) {
-		b_event_remove(irc->w_watch_source_id);
-	}
-
-	closesocket(irc->fd);
-	irc->fd = -1;
-
-	g_hash_table_destroy(irc->nick_user_hash);
-
-	g_hash_table_foreach_remove(irc->watches, irc_free_hashkey, NULL);
+	
+	if (irc->accounts != NULL) {
+		account = irc->accounts;
+		while (account != NULL) {
+			g_free(account->user);
+			g_free(account->pass);
+			g_free(account->server);
+			accounttmp = account;
+			account = account->next;
+			g_free(accounttmp);
+		}
+	}
+	
+	if (irc->users != NULL) {
+		user = irc->users;
+		while (user != NULL) {
+			g_free(user->nick);
+			g_free(user->away);
+			g_free(user->handle);
+			if(user->user!=user->nick) g_free(user->user);
+			if(user->host!=user->nick) g_free(user->host);
+			if(user->realname!=user->nick) g_free(user->realname);
+			gaim_input_remove(user->sendbuf_timer);
+					
+			usertmp = user;
+			user = user->next;
+			g_free(usertmp);
+		}
+	}
+	
+	g_hash_table_foreach_remove(irc->userhash, irc_free_userhash, NULL);
+	g_hash_table_destroy(irc->userhash);
+	
+	g_hash_table_foreach_remove(irc->watches, irc_free_userhash, NULL);
 	g_hash_table_destroy(irc->watches);
-
-	if (irc->iconv != (GIConv) - 1) {
-		g_iconv_close(irc->iconv);
-	}
-	if (irc->oconv != (GIConv) - 1) {
-		g_iconv_close(irc->oconv);
-	}
-
-	g_string_free(irc->sendbuffer, TRUE);
-	g_free(irc->readbuffer);
-	g_free(irc->password);
-
+	
+	if (irc->nicks != NULL) {
+		nick = irc->nicks;
+		while (nick != NULL) {
+			g_free(nick->nick);
+			g_free(nick->handle);
+					
+			nicktmp = nick;
+			nick = nick->next;
+			g_free(nicktmp);
+		}
+	}
+	if (irc->help != NULL) {
+		helpnode = irc->help;
+		while (helpnode != NULL) {
+			g_free(helpnode->string);
+			
+			helpnodetmp = helpnode;
+			helpnode = helpnode->next;
+			g_free(helpnodetmp);
+		}
+	}
+	if (irc->set != NULL) {
+		setnode = irc->set;
+		while (setnode != NULL) {
+			g_free(setnode->key);
+			g_free(setnode->def);
+			g_free(setnode->value);
+			
+			setnodetmp = setnode;
+			setnode = setnode->next;
+			g_free(setnodetmp);
+		}
+	}
 	g_free(irc);
-
-	if (global.conf->runmode == RUNMODE_INETD ||
-	    global.conf->runmode == RUNMODE_FORKDAEMON ||
-	    (global.conf->runmode == RUNMODE_DAEMON &&
-	     global.listen_socket == -1 &&
-	     irc_connection_list == NULL)) {
-		b_main_quit();
-	}
-}
-
-static gboolean irc_free_hashkey(gpointer key, gpointer value, gpointer data)
-{
-	g_free(key);
-
-	return(TRUE);
-}
-
-/* USE WITH CAUTION!
-   Sets pass without checking */
-void irc_setpass(irc_t *irc, const char *pass)
-{
-	g_free(irc->password);
-
-	if (pass) {
-		irc->password = g_strdup(pass);
-	} else {
-		irc->password = NULL;
-	}
-}
-
-static char *set_eval_password(set_t *set, char *value)
-{
-	irc_t *irc = set->data;
-
-	if (irc->status & USTATUS_IDENTIFIED && value) {
-		irc_setpass(irc, value);
-		return NULL;
-	} else {
-		return SET_INVALID;
-	}
-}
-
-static char **irc_splitlines(char *buffer);
-
-void irc_process(irc_t *irc)
-{
-	char **lines, *temp, **cmd;
+	
+	if( global.conf->runmode == RUNMODE_INETD )
+		g_main_quit( global.loop );
+}
+
+int irc_process( irc_t *irc )
+{
+	char **lines, *temp;	
 	int i;
 
-	if (irc->readbuffer != NULL) {
-		lines = irc_splitlines(irc->readbuffer);
-
-		for (i = 0; *lines[i] != '\0'; i++) {
-			char *conv = NULL;
-
-			/* [WvG] If the last line isn't empty, it's an incomplete line and we
-			   should wait for the rest to come in before processing it. */
-			if (lines[i + 1] == NULL) {
-				temp = g_strdup(lines[i]);
-				g_free(irc->readbuffer);
+	if( irc->readbuffer != NULL ) {
+		lines = irc_tokenize(irc->readbuffer );
+		for( i = 0; *lines[i] != '\0'; i++ ) {
+			if( lines[i+1] == NULL ) {
+				temp = g_strdup( lines[i] );
+				g_free( irc->readbuffer );
 				irc->readbuffer = temp;
 				i++;
 				break;
-			}
-
-			if (irc->iconv != (GIConv) - 1) {
-				gsize bytes_read, bytes_written;
-
-				conv = g_convert_with_iconv(lines[i], -1, irc->iconv,
-				                            &bytes_read, &bytes_written, NULL);
-
-				if (conv == NULL || bytes_read != strlen(lines[i])) {
-					/* GLib can do strange things if things are not in the expected charset,
-					   so let's be a little bit paranoid here: */
-					if (irc->status & USTATUS_LOGGED_IN) {
-						irc_rootmsg(irc, "Error: Charset mismatch detected. The charset "
-						            "setting is currently set to %s, so please make "
-						            "sure your IRC client will send and accept text in "
-						            "that charset, or tell BitlBee which charset to "
-						            "expect by changing the charset setting. See "
-						            "`help set charset' for more information. Your "
-						            "message was ignored.",
-						            set_getstr(&irc->b->set, "charset"));
-
-						g_free(conv);
-						conv = NULL;
-					} else {
-						irc_write(irc, ":%s NOTICE * :%s", irc->root->host,
-						          "Warning: invalid characters received at login time.");
-
-						conv = g_strdup(lines[i]);
-						for (temp = conv; *temp; temp++) {
-							if (*temp & 0x80) {
-								*temp = '?';
-							}
-						}
-					}
-				}
-				lines[i] = conv;
-			}
-
-			if (lines[i] && (cmd = irc_parse_line(lines[i]))) {
-				irc_exec(irc, cmd);
-				g_free(cmd);
-			}
-
-			g_free(conv);
-
-			/* Shouldn't really happen, but just in case... */
-			if (!g_slist_find(irc_connection_list, irc)) {
-				g_free(lines);
-				return;
-			}
-		}
-
-		if (lines[i] != NULL) {
+			}			
+			if (!irc_process_line(irc, lines[i])) {
+				g_free( lines );
+				return 0;
+			}
+		}
+		if(lines[i]!=NULL) {
 			g_free(irc->readbuffer);
-			irc->readbuffer = NULL;
-		}
-
-		g_free(lines);
-	}
-}
-
-/* Splits a long string into separate lines. The array is NULL-terminated
-   and, unless the string contains an incomplete line at the end, ends with
-   an empty string. Could use g_strsplit() but this one does it in-place.
-   (So yes, it's destructive.) */
-static char **irc_splitlines(char *buffer)
-{
-	int i, j, n = 3;
+			irc->readbuffer=NULL;	
+		}
+		g_free( lines );
+	}
+	return 1;	
+}
+
+char **irc_tokenize( char *buffer )
+{
+	int i, j;
 	char **lines;
 
-	/* Allocate n+1 elements. */
-	lines = g_new(char *, n + 1);
-
-	lines[0] = buffer;
-
-	/* Split the buffer in several strings, and accept any kind of line endings,
-	 * knowing that ERC on Windows may send something interesting like \r\r\n,
-	 * and surely there must be clients that think just \n is enough... */
-	for (i = 0, j = 0; buffer[i] != '\0'; i++) {
-		if (buffer[i] == '\r' || buffer[i] == '\n') {
-			while (buffer[i] == '\r' || buffer[i] == '\n') {
-				buffer[i++] = '\0';
-			}
-
-			lines[++j] = buffer + i;
-
-			if (j >= n) {
-				n *= 2;
-				lines = g_renew(char *, lines, n + 1);
-			}
-
-			if (buffer[i] == '\0') {
-				break;
-			}
-		}
-	}
-
-	/* NULL terminate our list. */
-	lines[++j] = NULL;
-
-	return lines;
-}
-
-/* Split an IRC-style line into little parts/arguments. */
-char **irc_parse_line(char *line)
+	/* Count the number of elements we're gonna need. */
+	for(i=0, j=1; buffer[i]!='\0'; i++ ) {
+		if(buffer[i]=='\n' )
+			if(buffer[i+1]!='\r' && buffer[i+1]!='\n')
+				j++;
+	}
+	
+	/* Allocate j+1 elements. */
+	lines=g_new (char *, j+1);
+	
+	/* NULL terminate our list. */ 
+	lines[j]=NULL;
+	
+	lines[0]=buffer;
+	
+	/* Split the buffer in several strings, using \r\n as our seperator, where \r is optional.
+	 * Although this is not in the RFC, some braindead ircds (newnet's) use this, so some clients might too. 
+	 */
+	for( i=0, j=0; buffer[i]!='\0'; i++) {
+		if(buffer[i]=='\n') {
+			buffer[i]='\0';
+
+			/* We dont want to read 1 byte before our buffer
+			 * and (in rare cases) generate a SIGSEGV.
+			 */
+			if(i!=0)
+				if(buffer[i-1]=='\r')
+					buffer[i-1]='\0';
+			if(buffer[i+1]!='\r'&&buffer[i+1]!='\n')
+				lines[++j]=buffer+i+1;
+		}
+	}
+
+	return(lines);
+}
+
+int irc_process_line( irc_t *irc, char *line )
 {
 	int i, j;
 	char **cmd;
-
+	
 	/* Move the line pointer to the start of the command, skipping spaces and the optional prefix. */
-	if (line[0] == ':') {
-		for (i = 0; line[i] && line[i] != ' '; i++) {
-			;
-		}
-		line = line + i;
-	}
-	for (i = 0; line[i] == ' '; i++) {
-		;
-	}
-	line = line + i;
+	if(line[0]==':') {
+		for(i=0; line[i]!=32; i++);
+		line=line+i;
+	}
+	for(i=0; line[i]==32; i++);
+	line=line+i;
 
 	/* If we're already at the end of the line, return. If not, we're going to need at least one element. */
-	if (line[0] == '\0') {
-		return NULL;
-	}
-
-	/* Count the number of char **cmd elements we're going to need. */
-	j = 1;
-	for (i = 0; line[i] != '\0'; i++) {
-		if (line[i] == ' ') {
+	if(line[0]=='\0')
+		return 1;
+	else
+		j=1;	
+	
+	/* Count the number of char **cmd elements we're going to need. */	
+	for(i=0; line[i]!='\0'; i++) {
+		if((line[i]==32) && (line[i+1]!=32) && (line[i+1]!='\0') && (line[i+1]!=':'))		
 			j++;
-
-			if (line[i + 1] == ':') {
-				break;
-			}
-		}
-	}
+		else if((line[i]==':') && (line[i+1]!='\0') && (line[i-1]==32)) {
+			j++;
+			break;
+		}
+			
+	}	
 
 	/* Allocate the space we need. */
-	cmd = g_new(char *, j + 1);
-	cmd[j] = NULL;
-
+	cmd=g_new(char *, j+1);
+	cmd[j]=NULL;
+	
 	/* Do the actual line splitting, format is:
 	 * Input: "PRIVMSG #bitlbee :foo bar"
